省流:\(200+\) 变 \(100+\)。

Day -6

打了把 abc,加了点分,还是没有完成 -s 前上蓝的心愿。

Day -3

打了把信心赛,被学弟打爆了,信心 -= inf。以此状态,何以 csp?

Day -2

刷了点模板,感觉唯一有点用的是 Tarjan 和高斯消元。

Day 0

上午根本写不进题了,于是又回顾了一下之前的总结以及易犯的错误。下午出发去郑州,坐大巴坐了两个小时,晕车人士狂喜。到酒店后也没干啥正经事。

Day 1

上午的 -j 当然是不打的,中午看了看刚出炉的题面,竟然是红橙黄绿,T3 是神秘拆位,T4 还要观察一些性质,吓哭了。下午不能是青蓝紫黑吧。

下午一点多进考场了,考前忽然发现自己好像没复习 AC 自动机,但是去年考了今年估计不考了吧。

14:30 开考,之前一直对 T1 有些恐惧(原因是去年被 T1 肘飞了),但是看到题后有点想笑。简化题意就是,对 \(n\) 个数进行 \(m\) 次操作,每次选择一个数加一,问最终同种数字的个数的最大值。显然想到枚举每个 \(a_i\),钦定它是最终选定的值,只能让 \(\le a_i\) 的数变成 \(a_i\),而且越接近 \(a_i\) 的越优秀。于是把 \(a\) 排序,对于每个 \(i\) 二分找到最大的合法左端点。

大概 14:40 多一点通过 T1 大样例,去看 T2,被长长的题面吓哭了。这个样例解释怎么有问题啊,上面标的公式是错的,不过懒得给老师说了。这个题意怎么也有问题啊,地铁竟然是双向的,要不是我看到保证地铁站之间连通我还被蒙在鼓里,这个题意描述很容易让人误会,一直提到依次经过,显得好像是单向的。然后我被单向坑了很久,先 \(\sum k^2\) 建图吧,然后 \(q\sum k \log \sum k\) 地求答案。想不到怎么优化。

后面大概 15:00 终于发现双向了,那就简单了,先优化建图,每条地铁线建虚拟节点,把线上经过的地铁站连向虚拟节点,由于 \(n \le 500\),比较显然地想到要对虚拟节点跑 Floyd 最短路,而且由于每个地铁站度数 \(\le d\),这样初始化就是 \(O(m d^2)\),Floyd 是 \(O(n^3)\),求答案是 \(O(qd^2)\)。有点极限啊。

然后就是疯狂卡常,突发奇想能不能钦定 Floyd 里面的 \(dis_{i, j}\) 只用到 \(i \le j\) 的部分,那常数直接带个 \(\frac{1}{2}\) 了呀!大概 16:00 通过 T2 大样例,并且把能卡常的都卡了,还是担心会被卡常。

T3 容易想到 \(O(n^2)\) 的暴力,但是写着写着发现是 \(O(n^3)\) 的,不管了先写吧。然后 B 性质推了推式子,拍了几组小样例都过了。A 性质似乎也是推式子,此时认为 T4 更有性价比,于是去看 T4 了,时间是 16:30 左右。

T4 只能想到 \(O(n^2 2^n)\),有高贵的 \(15\) 分,后面还有一版 \(O(n^2k^2)\) 的暴力 DP,但是没推转移式,也没写。

17:00 这里开始苦思冥想 T3,终于还是败了。接下来是长达 90 分钟的颓颓。

也是熬到 18:30 了,出考场发现 T1, T2 是人均。那我的都是大众分了?感觉还是可能拿 \(\sqrt{7}\) 的。

回来的路上,吃晕车药并没有效果,于是难受了两个小时。

Day 2

洛谷自测了一下代码,怎么 T2 全挂了。悲。原因是我那个突发奇想的优化错了!但是目前仍然不知道哪里错了。喜提 \(0 pts\)。我就说嘛要是真有这么神的优化会没有前人想到吗。